#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define ERROR	-1

int my_strchr(const char str[], int offset, char c)
{
	int i;

	for (i = offset; str[i] != '\0'; i++)
	{
		if (str[i] == c)
			return i;
	}

	return ERROR;
}

int my_strlen(const char str[])
{
	int i;

	for (i = 0; str[i] != '\0'; i++);

	return i;
}

int my_strncmp(const char str1[], int offset, const char str2[])
{
	int i, count = 0;
	int str2_len = my_strlen(str2);

	for (i = 0; str1[i + offset] != '\0' && str2[i] != '\0'; i++)
		if (str1[i + offset] == str2[i])
			count++;
	return count - str2_len;
}

int my_strstr(const char haystack[], const char needle[], int offset)
{
	int needlelen;

	if (needle[0] == '\0') 
		return 0;

	needlelen = my_strlen(needle);
	offset = my_strchr(haystack, offset, needle[0]);
	while (offset != -1) {
		if (my_strncmp(haystack, offset, needle) == 0)
			return offset;
		offset++;
		offset = my_strchr(haystack, offset, needle[0]);
	}

	return ERROR; 
}

int main()
{
	const char rhyme[] =  "Humpty Dumpty sat on a wall,\n"
			  	          "Humpty Dumpty had a great fall.\n"
						  "All the king's horses,\n"
						  "And all the king's men,\n"
						  "Couldn't put Humpty together again.\n";
	const char humpty[] = "Humpty";
	int index = 0;
	int count = 0;
	
	/* count occurances of humpty in rhyme */
	for (index = my_strstr(rhyme, humpty, index);
		 index != ERROR;
		 index = my_strstr(rhyme, humpty, index + 1))
	{
		count++;
	}

	printf("The string %s appears %d times\n", humpty, count);

	return 0;
}